VERSION 5.00
Begin VB.Form frmEdit 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Carrier - Level Editor"
   ClientHeight    =   3300
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   4680
   ForeColor       =   &H00FFFFFF&
   Icon            =   "EditLevels.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3300
   ScaleWidth      =   4680
   Begin VB.PictureBox picGrid 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H00FFFFFF&
      Height          =   3255
      Left            =   600
      ScaleHeight     =   3255
      ScaleWidth      =   4095
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   0
      Width           =   4095
   End
   Begin VB.PictureBox picStrip 
      BorderStyle     =   0  'None
      Height          =   3255
      Left            =   0
      ScaleHeight     =   3255
      ScaleWidth      =   615
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   615
      Begin VB.OptionButton optObject 
         Height          =   615
         Index           =   0
         Left            =   0
         Style           =   1  'Graphical
         TabIndex        =   1
         Top             =   0
         Width           =   615
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New..."
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Index           =   0
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "Save &As..."
         Index           =   1
      End
      Begin VB.Menu mnuFileSplit2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileQuit 
         Caption         =   "&Quit"
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditProperties 
         Caption         =   "&Level Properties..."
      End
   End
   Begin VB.Menu mnuGame 
      Caption         =   "&Game"
      Begin VB.Menu mnuGamePlay 
         Caption         =   "&Play this Level..."
         Index           =   0
      End
      Begin VB.Menu mnuGamePlay 
         Caption         =   "&Return to Game"
         Index           =   1
      End
   End
End
Attribute VB_Name = "frmEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim SelectedObject As Integer    ' Object in 'toolbar'
Dim Size As Integer              ' Size of object to draw
Dim MouseDown As Boolean         ' Is mouse down?
Public CancelEditProp As Boolean ' EditProperties canceled?
Dim Saved As Boolean             ' Saved recent changes?



'----------------------------------------------------------------
' Initialize

Private Sub Form_Activate()
  Set ActiveForm = Me
End Sub

Private Sub Form_Load()
  ' Make the toolbar
  Call MakeToolbar
  
  ' Set misc variables
  Saved = True
  Size = (OBJECT_SIZE) * PIXEL
  optObject(WALL).Value = True
  
  ' Draw, resize and set variables
  Call RefreshAll
End Sub

Private Sub Form_Resize()
  ' Toolbar needs to be height of inner window
  Me.picStrip.Height = Me.ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
  ' Save changes or exit program?
  If Not SaveChanges() Then
    Cancel = True
  ElseIf Game.Mode = MODE_EDIT Then
    Call ExitProgram
  End If
End Sub



'----------------------------------------------------------------
' Menu Items

Public Sub mnuFileNew_Click()
  Dim I As Integer
  Dim J As Integer
  
  ' Save changes?
  If Not SaveChanges() Then Exit Sub
  
  ' Show the settings dialog to define the settings first
  Load frmEditProperties
  Call frmEditProperties.Show(vbModal, Me)
  If Me.CancelEditProp Then Exit Sub
  
  ' Initialize the new level
  Saved = False
  Call ClearLevel(True)
  Call RefreshAll
End Sub

Private Sub mnuFileOpen_Click()
  ' Save changes? and open the file
  If Not SaveChanges() Then Exit Sub
  If OpenLevelDialog(True) Then Call RefreshAll
End Sub

Private Sub mnuFileQuit_Click()
  ' Save changes? amd quit
  If Not SaveChanges() Then Exit Sub
  Call ExitProgram
End Sub

Private Sub mnuFileSave_Click(Index As Integer)
  ' Note: The SaveLevel is also called elsewhere.
  Saved = SaveLevel(Index)
End Sub


'----------------------------------------------------------------
' Editor Special Menu's

Private Sub mnuEditProperties_Click()
  ' Load the settings into the edit properties dialiog
  Call frmEditProperties.LoadSettings(False)
  Call frmEditProperties.Show(vbModal, Me)
  
  ' Set variables when not cancel pressed
  If Not Me.CancelEditProp Then
    Call SetFormCaption
    Saved = False
  End If
End Sub

Private Sub mnuGamePlay_Click(Index As Integer)
  Dim StripWidth As Single
  
  If Index = PLAY_THIS Then
    ' Test for playability
    If Not LevelIsPlayable(Game.PlayedLevel) Then
      MsgBox "This level is not playable!", vbExclamation
      Exit Sub
    End If
    
    ' Load the level into the game
    Call LoadEditedLevel
    Game.Mode = MODE_PLAYTEST
  Else
    ' Save changes?
    If Not SaveChanges() Then Exit Sub
    
    ' Clear the level
    Call ClearLevel(False)
    Game.Mode = MODE_PLAY
  End If
  
  ' Load the main window, and position it.
  Load frmMain
  StripWidth = picStrip.Left + picStrip.Width
  frmMain.Move Me.Left + StripWidth, Me.Top
  If frmMain.Left + frmMain.Width > Screen.Width Then frmMain.Left = Screen.Width - frmMain.Width
  
  ' Show the game
  Call frmMain.InitializeGame
  frmMain.Visible = True
  
  ' Unload me, or keep me at the background?
  If Game.Mode = MODE_PLAY Then
    Unload Me
  Else
    Me.Visible = False
  End If
End Sub


'----------------------------------------------------------------
' Toolbar

Private Sub optObject_Click(Index As Integer)
  ' The toolbar button is pressed
  SelectedObject = Index
End Sub

Private Sub MakeToolbar()
  Dim I As Integer
  
  For I = 0 To OBJECT_IMAGES
    ' Load and position
    If I > 0 Then
      Load optObject(I)
      optObject(I).Top = optObject(I - 1).Top + optObject(0).Height
      optObject(I).Left = optObject(0).Left
    End If
    
    ' Assign picture
    If I = PLAYER Then
      optObject(I).Picture = Game.PLAYER(STANDLEFT)
    Else
      If Game.Object(I) Is Nothing Then
        optObject(I).Caption = "?"
      Else
        optObject(I).Picture = Game.Object(I)
      End If
    End If
    
    ' Visible
    optObject(I).Visible = True
  Next
End Sub


'----------------------------------------------------------------
' Grid Window

Private Sub picGrid_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  MouseDown = True
  Call picGrid_MouseMove(Button, Shift, X, Y) ' In case a (fast) click occurs without a mouse move
End Sub

Private Sub picGrid_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim GridX As Integer
  Dim GridY As Integer
  Dim DrawObj As Integer
  
  If Not MouseDown Then Exit Sub
  
  ' Object to draw
  DrawObj = IIf(Button = vbLeftButton, SelectedObject, SPACE)
  
  ' Position where to draw
  GridX = Int(X / Size)
  GridY = Int(Y / Size)
  If GridX < 0 Then GridX = 0
  If GridY < 0 Then GridY = 0
  If GridX > Game.PlayedLevel.Width - 1 Then GridX = Game.PlayedLevel.Width - 1
  If GridY > Game.PlayedLevel.Height - 1 Then GridY = Game.PlayedLevel.Height - 1
  
  ' Don't draw in come cases
  If Game.PlayedLevel.Fields(GridX, GridY) = DrawObj Then Exit Sub
  If GridX = Game.PlayedLevel.PLAYER.X And GridY = Game.PlayedLevel.PLAYER.Y Then Exit Sub
  
  If SelectedObject = PLAYER Then
    ' Clear the field under the player (where he stands now)
    ' The player might not be drawn, or
    ' placed outside the grid.
    
    On Error Resume Next
      Call DrawFieldItem(picGrid, , , Game.Object(SPACE))
      If Err.Number <> 0 And Err.Number <> 9 Then ' Not OK, or out of subscript...
        ' Something strange happened
        MsgBox "Runtime error " & Err.Number & vbCrLf & Err.Description, vbExclamation
        Call ExitProgram
        End
      End If
    On Error GoTo 0
    
    ' Set variables and draw
    Game.PlayedLevel.PLAYER.X = GridX
    Game.PlayedLevel.PLAYER.Y = GridY
    Game.PlayedLevel.Fields(GridX, GridY) = SPACE ' It's empty under player now
    Call DrawFieldItem(picGrid)
  Else
    ' Set variables and draw
    Game.PlayedLevel.Fields(GridX, GridY) = DrawObj
    Call DrawFieldItem(picGrid, GridX, GridY)
  End If
  
  ' The last change is not saved...
  Saved = False
  
  ' Redraw the grid
  Call DrawGrid
End Sub

Private Sub picGrid_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  MouseDown = False ' No more dragging at the screen
End Sub


'----------------------------------------------------------------
' Drawing the window


' This subroutine is required only if the AutoRedraw
' property is set to False
Private Sub picGrid_Paint()
  Call DrawField(Me.picGrid)
  Call DrawGrid
End Sub

Private Sub DrawGrid()
  ' Draw the grid
  Dim I As Integer
  Dim GridX As Integer
  Dim GridY As Integer
  Dim GridWidth As Single
  Dim GridHeight As Single
  
  GridWidth = picGrid.ScaleWidth
  GridHeight = picGrid.ScaleHeight
  
  GridX = Round(GridWidth / Size, 1)
  GridY = Round(GridHeight / Size, 1)
  
  For I = 0 To GridX
    picGrid.Line (I * CLng(Size), 0)-Step(0, GridHeight)
  Next
  For I = 0 To GridY
    picGrid.Line (0, I * CLng(Size))-Step(GridWidth, 0)
  Next
End Sub


'----------------------------------------------------------------
' Window size, position, caption

Public Sub RefreshAll()
  ' Makes the form look like we want it to be
  Call SetFormCaption
  Call ScaleToField(picGrid)
  Call SetFormSize
  Call DrawField(Me.picGrid)
  Call DrawGrid
End Sub

Private Sub SetFormSize()
  Dim TryHeight As Single
  TryHeight = picGrid.Top + picGrid.Height
  If TryHeight < (optObject(OBJECT_IMAGES).Top + optObject(OBJECT_IMAGES).Height) Then
    TryHeight = optObject(OBJECT_IMAGES).Top + optObject(OBJECT_IMAGES).Height
  End If
  Me.Width = (Me.Width - Me.ScaleWidth) + picGrid.Left + picGrid.Width
  Me.Height = (Me.Height - Me.ScaleHeight) + TryHeight
End Sub

Private Sub SetFormCaption()
  If Game.PlayedLevel.Name <> "" Then
    Me.Caption = "Carrier - Level Editor [" & Game.PlayedLevel.Name & "]"
  Else
    Me.Caption = "Carrier - Level Editor"
  End If
End Sub


'----------------------------------------------------------------
' Save Utility

Public Function SaveChanges() As Boolean
  ' Saved?
  If Not Saved Then
    ' Show messagebox
    Dim Reply As VbMsgBoxResult
    Reply = MsgBox("Save changes to level?", vbYesNoCancel Or vbExclamation)
    
    If Reply = vbYes Then
      SaveChanges = SaveLevel(SAVE_NORMAL) ' False in canceled
    ElseIf Reply = vbNo Then
      SaveChanges = True
    ElseIf Reply = vbCancel Then
      ' caller shouldn't continue running more code
      SaveChanges = False
    End If
    
    Saved = SaveChanges
  Else
    SaveChanges = True
  End If
End Function

