VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Carrier"
   ClientHeight    =   3195
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   21.75
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H000080FF&
   Icon            =   "MainWindow.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileAbout 
         Caption         =   "&About..."
      End
      Begin VB.Menu mnuFileSplit 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileQuit 
         Caption         =   "&Quit"
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditUndo 
         Caption         =   "&Undo"
         Enabled         =   0   'False
         Shortcut        =   ^Z
      End
      Begin VB.Menu mnuEditRetry 
         Caption         =   "&Retry Level"
         Enabled         =   0   'False
         Shortcut        =   {F5}
      End
      Begin VB.Menu mnuEditNext 
         Caption         =   "Play &Next Level"
      End
   End
   Begin VB.Menu mnuTools 
      Caption         =   "&Tools"
      Begin VB.Menu mnuToolsEditor 
         Caption         =   "&Level Editor..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


'----------------------------------------------------------------
' Form Lifetime Helpers

Private Sub Form_Activate()
  Set ActiveForm = Me
End Sub

Private Sub Form_Paint()
  ' Done every time.
  ' No autoredraw is used, since that doesn't update that
  ' fast with our animations.
  Call DrawField(Me)
  If Game.Complete And Game.StepsDone > 0 Then Call DrawComplete
End Sub

Private Sub Form_Load()
  Call InitializeGame
End Sub

Private Sub Form_Unload(Cancel As Integer)
  If Game.Mode = MODE_PLAYTEST Then
    If Not frmEdit.SaveChanges() Then
      Cancel = True
      Exit Sub
    End If
  End If
  
  Call ExitProgram
End Sub

Private Sub mnuFileQuit_Click()
  Call ExitProgram
End Sub

Private Sub mnuFileAbout_Click()
  MsgBox "Carrier" & vbCrLf _
       & "Copyright (c) 2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "This game has been ported form a 'Supervision' * game." & vbCrLf _
       & "(smal handled gamecomputer where you put a card in to play that game)" & vbCrLf _
       & vbCrLf _
       & "http://www.cool-programming.f2s.com", vbInformation
End Sub


'----------------------------------------------------------------
' Load in a level

Private Sub mnuFileOpen_Click()
  If Game.Mode = MODE_EDIT Then Exit Sub
  If Game.Mode = MODE_PLAYTEST Then
    ' This is caused by some variable conflics,
    ' and there is no way in the game for changing
    ' so dramatically fast from mode
    If MsgBox("Can't load an other level; the editor is in use!" & vbCrLf _
            & "Whould you like to go to the editor now?", _
              vbYesNo Or vbQuestion) = vbYes Then Call mnuToolsEditor_Click
    Exit Sub
  End If
  
  ' Open a level from dialog box.
  If OpenLevelDialog(False) Then
    Call InitializeGame
    Call DrawField(Me)
  End If
End Sub

'----------------------------------------------------------------
' The control of the game

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  Dim LocField As LOCATION
  Dim LocFieldTo As LOCATION
  Dim LocFieldToNext As LOCATION
  Dim FieldTo As Byte
  Dim FieldToNext As Byte
  
  If InAnimation Then Exit Sub
  If Game.Complete Then Exit Sub
  
  If Not (KeyCode = vbKeyLeft Or KeyCode = vbKeyRight Or KeyCode = vbKeyUp Or KeyCode = vbKeyDown) Then Exit Sub
  
  ' Get Offset field
  LocField = Game.PlayedLevel.PLAYER
  LocFieldTo = FieldOffset(KeyCode, 1)
  LocFieldToNext = FieldOffset(KeyCode, 2)
  FieldTo = Game.PlayedLevel.Fields(LocFieldTo.X, LocFieldTo.Y)
  FieldToNext = Game.PlayedLevel.Fields(LocFieldToNext.X, LocFieldToNext.Y)
  
  If FieldTo = SPACE Or FieldTo = TARGET Then
    ' May move to if it's empty target or space
    Call ShowPlayerAnim(Me, KeyCode, False)
    Game.PlayedLevel.PLAYER = LocFieldTo
    Call DrawFieldItem(Me, LocField.X, LocField.Y)
    Call DrawFieldItem(Me, LocFieldTo.X, LocFieldTo.Y)
    Game.StepsDone = Game.StepsDone + 1
    Game.PrevStep = KeyCode
  ElseIf FieldTo = BOX Or FieldTo = BOXATTARGET Then
    ' Box or box at target may move if there after is target or space
    If FieldToNext = SPACE Or FieldToNext = TARGET Then
      Call SaveUndo(Game.PlayedLevel.PLAYER, LocFieldTo, LocFieldToNext)
      Game.PlayedLevel.Fields(LocFieldTo.X, LocFieldTo.Y) = (FieldTo And Not BOX)         ' BOXATTARGET BitAnd Not BOX = TARGET; BOX BitAnd BitNot BOX = SPACE
      Game.PlayedLevel.Fields(LocFieldToNext.X, LocFieldToNext.Y) = (FieldToNext Or BOX)  ' SPACE BitOr BOX = BOX;               TARGET BitOr BOX = BOXATTARGET
      Call ShowPlayerAnim(Me, KeyCode, True)
      Game.PlayedLevel.PLAYER = LocFieldTo
      Call DrawFieldItem(Me, LocField.X, LocField.Y)
      Call DrawFieldItem(Me, LocFieldTo.X, LocFieldTo.Y)
      Call DrawFieldItem(Me, LocFieldToNext.X, LocFieldToNext.Y)
      Game.StepsDone = Game.StepsDone + 1
      Game.PrevStep = KeyCode
    End If
  End If
  
  If IsComplete() Then
    Game.Complete = True
    Call ShowPlayerAnim(Me, 0, False)
    DrawComplete
    Call Sleep(1000)
    Call mnuEditNext_Click
  End If
End Sub


'----------------------------------------------------------------
' Menus about the gameplay

Private Sub mnuEdit_Click()
  mnuEditUndo.Enabled = (Game.StepsDone > 0)
  mnuEditRetry.Enabled = (Game.StepsDone > 0 And Game.UndoAvailable)
  mnuEditNext.Enabled = (Game.FileName <> "" And Game.Mode = MODE_PLAY)
End Sub

Private Sub mnuEditNext_Click()
  Dim NextLevel As String
  
  NextLevel = GetNextLevel()
  If NextLevel <> "" Then
    Call LoadLevel(NextLevel, False)
    Call InitializeGame
    Call DrawField(Me)
  Else
    MsgBox "You're done!" & vbCrLf & vbCrLf & "This is the end of these levels.", vbInformation
  End If
End Sub

Private Sub mnuEditRetry_Click()
  Call RestoreLevel
  Call InitializeGame
  Call DrawField(Me)
End Sub

Private Sub mnuEditUndo_Click()
  Dim LocPrevField As LOCATION
  
  Game.UndoAvailable = False
  If Game.StepsDone = 0 Then Exit Sub
  Game.StepsDone = Game.StepsDone - 1
  With Game.Undo(0)
    Call DrawFieldItem(Me, , , Game.Object(Game.PlayedLevel.Fields(Game.PlayedLevel.PLAYER.X, Game.PlayedLevel.PLAYER.Y)))
    Game.PlayedLevel.PLAYER = .PlayerPos
    Game.PlayerStyle = .PlayerStyle
    Game.PlayedLevel.Fields(.NextPos.X, .NextPos.Y) = .NextValue
    Game.PlayedLevel.Fields(.NextAfterPos.X, .NextAfterPos.Y) = .NextAfterValue
    Call DrawFieldItem(Me, .NextAfterPos.X, .NextAfterPos.Y)
    Call DrawFieldItem(Me, .NextPos.X, .NextPos.Y)
    Call DrawFieldItem(Me, .PlayerPos.X, .PlayerPos.Y)
  End With
End Sub



'----------------------------------------------------------------
' Level Editor!!!! ;-)

Private Sub mnuTools_Click()
  If Game.Mode = MODE_PLAY Then
    mnuToolsEditor.Caption = "Level Editor..."
  Else
    mnuToolsEditor.Caption = "Edit Level..."
  End If
End Sub

Private Sub mnuToolsEditor_Click()
  Dim StripWidth As Single
  
  Load frmEdit
  
  ' Restore level, or make new level?
  Call RestoreVariables
  If Game.Mode = MODE_PLAYTEST Then
    Call RestoreLevel
  Else
    Call InitDefaultEditLevel
  End If
  
  StripWidth = frmEdit.picStrip.Left + frmEdit.picStrip.Width
  
  frmEdit.Move Me.Left - StripWidth, Me.Top
  If frmEdit.Left < 0 Then frmEdit.Left = 0
  If frmEdit.Top < 0 Then frmEdit.Top = 0
  frmEdit.Icon = Me.Icon
  
  Call frmEdit.RefreshAll
  Game.Mode = MODE_EDIT
  
  frmEdit.Visible = True
  Me.Visible = False
End Sub



'----------------------------------------------------------------
' Helper routines

Public Sub InitializeGame()
  Call ScaleToField(Me)
  Call RestoreVariables
  
  ' Update the user interface
  If Game.PlayedLevel.Name <> "" Then
    Me.Caption = "Carrier [" & Game.PlayedLevel.Name & "]"
  Else
    Me.Caption = "Carrier"
  End If
End Sub

